CREATE OR REPLACE FUNCTION ARQUIVO_DACON_R25(
     P_CDEMPRESA              IN EMPRESA.CDEMPRESA%TYPE,
     P_DTINICIO               IN NOTAFISCAL.DTENTRSAID%TYPE,
     P_DTFIM                  IN NOTAFISCAL.DTENTRSAID%TYPE,
     P_NRSEQARQMAG            IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
     P_PISPASEP               IN VARCHAR2) RETURN NUMBER
  AS
     V_CONTREG25        NUMBER;
  BEGIN
   /*----------------------------------R25A-------------------------------------*/
   IF (P_PISPASEP = '3') THEN
      FOR C_REG_R25A IN (SELECT (RPAD('R25A',4,' ')        ||
                                  TO_CHAR(P_DTINICIO,'MM') ||
                                  '01'                     ||
                                  LPAD('0',14,'0')         || --Calculado automaticamente: Soma da Linha 18A/04 (Coluna Contribuio); valor da Linha 18B/26 ou valor da Linha 18C/17.
                                  LPAD('0',14,'0')         || --Calculado automaticamente: "Valor Apurado" da Ficha 19A
                                  LPAD('0',14,'0')         || --Calculado automaticamente: "Valor Apurado" da Ficha 19B
                                  LPAD('0',14,'0')         || --Calculado automaticamente: "Valor Apurado" da Ficha 20A
                                  LPAD('0',14,'0')         || --Calculado automaticamente: "Valor Apurado" da Ficha 20B
                                  LPAD('0',14,'0')         || --Calculado automaticamente: "Contribuio Adicionada" da Ficha 21
                                  LPAD('0',14,'0')         || --Calculado automaticamente: "Crdito Adicionado" da Ficha 21
                                  LPAD('0',14,'0')         || --Calculado automaticamente: "Contribuio Diferida" da Ficha 22
                                  LPAD('0',14,'0')         || --Calculado automaticamente: Soma das Linhas 25A/01 a 25A/08
                                  LPAD('0',14,'0')         || --Cofins Retida na Fonte por rgos, Autarquias e Fundaes Federais
                                  LPAD('0',14,'0')         || --Cofins Retida na Fonte pelas Demais Entidades da Administrao Pblica Federal
                                  LPAD(LTRIM(REPLACE(TO_CHAR(SUM(NVL(B.VR06,0)),'000000000000.00'),'.')),'14','0')   || --Cofins Retida na Fonte por Pessoas Jurdicas de Direito Privado
                                  LPAD(LTRIM(REPLACE(TO_CHAR(SUM(NVL(B.VR05,0)),'000000000000.00'),'.')),'14','0')   || --Cofins Retida na Fonte por rgos, Autarquias e Fundaes dos Estados, Distrito Federal e Municpios
                                  LPAD('0',14,'0')         || --Cofins Retida na Fonte por Sociedade Cooperativa
                                  LPAD('0',14,'0')         || --Cofins Retida na Fonte por Fabricantes de Veculos e Mquinas
                                  LPAD('0',14,'0')         || --Cofins Substituio pela no Ocorrncia do Fato Gerador Presumido
                                  LPAD('0',14,'0')         || --Crdito Presumido  Medicamentos
                                  LPAD('0',14,'0')         || --Crditos Admitidos no Regime Cumulativo
                                  LPAD('0',14,'0')         || --Cofins Paga pelo Substituto Tributrio
                                  LPAD('0',14,'0')         || --Outras Dedues
                                  LPAD('0',14,'0')         || --Calculado automaticamente: Soma das Linhas 25A/01 a 25A/20  Faturamento
                                  LPAD('0',14,'0')         || --Cofins a pagar de SCP
                                  LPAD('0',14,'0')         || --Cofins a pagar retida de cooperados
                                  LPAD('0',178,'0')        ||
                                  LPAD('0',10,'0'))REG_R25A
                           FROM
                              (SELECT TO_CHAR(A.VRIMPOSTOIT) AS VR01,
                                      (CASE WHEN A.CDSITUTRIBITNFE = '02' THEN  TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR02,
                                      (CASE WHEN ((A.CDSITUTRIBITNFE = '05')AND(VRALIQITEM > 0.00))THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR03,
                                      (CASE WHEN A.CDSITUTRIBITNFE = '03' THEN  TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR04,
                                      (CASE WHEN ((A.IDPRIPUBFORN  = 'B') OR (A.IDPRIPUBCLIE = 'B')) THEN TO_CHAR((VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '65', 'I') + VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '66', 'I'))) ELSE LPAD('0',14,'0') END) AS VR05,
                                      (CASE WHEN ((A.IDPRIPUBFORN  = 'V') OR (A.IDPRIPUBCLIE = 'V')) THEN TO_CHAR((VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '65', 'I') + VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '66', 'I'))) ELSE LPAD('0',14,'0') END) AS VR06
                                 FROM
                                    (SELECT VRCONTITIMP, VRIMPOSTOIT,CDSITUTRIBITNFE,VRALIQITEM,FO.IDPRIPUBFORN, CL.IDPRIPUBCLIE, IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD
                                       FROM ITEMPROIMPOS IT, ITEMPRODUTO IP,IMPOSTO IM, NOTAFISCAL N, FILIAL F,FORNECEDOR FO, CLIENTE CL,
                                          (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                             FROM IMPOSTONF I, MAPAAPURAC M
                                            WHERE M.CDIMPOSTO     =  '60'
                                              AND M.CDEMPRESA     =  P_CDEMPRESA
                                              AND M.DTINIPERIODO  >= P_DTINICIO
                                              AND M.DTFIMPERIODO  <= P_DTFIM
                                              AND M.NRSEQUMAPAPU  =  I.NRSEQUMAPAPU) NOTA
                                      WHERE IT.CDFILIAL        = NOTA.CDFILIAL
                                        AND IT.NRLANCTONF      = NOTA.NRLANCTONF
                                        AND IT.CDIMPOSTO       = IM.CDIMPOSTO
                                        AND IM.CDIMPOSTONFE    = '60'
                                        AND IT.CDFILIAL        = IP.CDFILIAL
                                        AND IT.NRLANCTONF      = IP.NRLANCTONF
                                        AND IT.NRSEQITPROD     = IP.NRSEQITPROD
                                        AND N.CDFILIAL         = IT.CDFILIAL
                                        AND N.NRLANCTONF       = IT.NRLANCTONF
                                        AND N.CDFILIAL         = NOTA.CDFILIAL
                                        AND N.NRLANCTONF       = NOTA.NRLANCTONF
                                        AND DECODE(IDENTRSAIDOP,'S',N.CDFILIEMIT,N.CDFILIRECE) = F.CDFILIAL
                                        AND F.IDCUMUPISCOFIL   = 'N'
                                        AND N.CDFORNECED       = FO.CDFORNECED(+)
                                        AND N.CDCLIENTE        = CL.CDCLIENTE(+)
                                        AND N.IDENTRSAIDOP     = 'S'
                                    )A
                              )B
                          GROUP BY 'R25A', TO_CHAR(P_DTINICIO,'MM'),'01'
      ) LOOP

         V_CONTREG25 := NVL(V_CONTREG25,0) + 1;


         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            ('24'||LPAD(RTRIM(V_CONTREG25), 8, '0'), C_REG_R25A.REG_R25A, P_NRSEQARQMAG);

      END LOOP;

   /*----------------------------------R25B-------------------------------------*/
  ELSIF ((P_PISPASEP ='1')OR(P_PISPASEP = '2')) THEN
     FOR C_REG_R25B IN (SELECT (RPAD('R25B',4,' ')         ||
                                 TO_CHAR(P_DTINICIO,'MM')  ||
                                 '01'                      ||
                                 LPAD('0',14,'0')          || --Calculado automaticamente: Coluna "Contribuio" das Linhas 17A/03, 17B/03 e 17B/07.
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Valor Apurado" da Ficha 19A
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Valor Apurado" da Ficha 19B
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Valor Apurado" da Ficha 20A
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Valor Apurado" da Ficha 20B
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Contribuio Adicionada" da Ficha 21
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Contribuio Diferida" da Ficha 22
                                 LPAD('0',14,'0')          || --Calculado automaticamente: Soma das Linhas 25B/01 a 25B/07
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Crdito Descontado no Ms" das Fichas 23A e 23B Cdigo de Tipo de Crdito 1
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Crdito Descontado no Ms" das Fichas 23A e 23B Cdigo de Tipo de Crdito 2
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Crdito Descontado no Ms" das Fichas 23A e 23B Cdigo de Tipo de Crdito 3
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Crdito Descontado no Ms" das Fichas 23A e 23B Cdigo de Tipo de Crdito 4
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Crdito Descontado no Ms" das Fichas 23A e 23B Cdigo de Tipo de Crdito 5
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Crdito Descontado no Ms" das Fichas 23A e 23B Cdigo de Tipo de Crdito 6
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Crdito Descontado no Ms" das Fichas 23A e 23B Cdigo de Tipo de Crdito 7
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Crdito Descontado no Ms" das Fichas 23A e 23B Cdigo de Tipo de Crdito 8
                                 LPAD('0',14,'0')          || --Calculado automaticamente: Soma das Linhas 25B/08 a 25B/16
                                 LPAD('0',14,'0')          || --Cofins Retida na Fonte por rgos, Autarquias e Fundaes Federais
                                 LPAD('0',14,'0')          || --Cofins Retida na Fonte pelas Demais Entidades da Administrao Pblica Federal
                                 LPAD(LTRIM(REPLACE(TO_CHAR(SUM(NVL(B.VR19,0)),'000000000000.00'),'.')),'14','0') || --Cofins Retida na Fonte por Pessoas Jurdicas de Direito Privado
                                 LPAD(LTRIM(REPLACE(TO_CHAR(SUM(NVL(B.VR20,0)),'000000000000.00'),'.')),'14','0') || --Cofins Retida na Fonte por rgos, Autarquias e Fundaes dos Estados, Distrito Federal e Municpios
                                 LPAD('0',14,'0')          || --Cofins Retida na Fonte por Sociedade Cooperativa
                                 LPAD('0',14,'0')          || --Cofins Retida na Fonte por Fabricantes de Veculos e Mquinas
                                 LPAD('0',14,'0')          || --Cofins Substituio pela no Ocorrncia do Fato Gerador Presumido
                                 LPAD('0',14,'0')          || --Crdito Presumido  Medicamentos
                                 LPAD('0',14,'0')          || --Para coluna 1 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Cofins Paga pelo Substituto Tributrio
                                 LPAD('0',14,'0')          || --Outras Dedues
                                 LPAD('0',14,'0')          || --Calculado automaticamente: Soma das Linhas 15B/17 a 15B/28 --Faturamento
                                 LPAD('0',14,'0')          || --Cofins a pagar de SCP
                                 LPAD('0',14,'0')          || --Cofins a pagar retida de cooperados
                                 LPAD('0',66,'0')          ||
                                 LPAD('0',10,'0'))REG_R25B
                          FROM
                             (SELECT TO_CHAR(A.VRIMPOSTOIT) AS VR01,
                                     (CASE WHEN A.CDSITUTRIBITNFE = '02' THEN  TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0')END) AS VR02,
                                     (CASE WHEN ((A.CDSITUTRIBITNFE = '05')AND(VRALIQITEM > 0.00))THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR03,
                                     (CASE WHEN A.CDSITUTRIBITNFE = '03' THEN  TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR04,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('101','102','103','104','107','108','109','199')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1')) THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR09,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('201','202','203','204','207','208','209','299')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1')) THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR10,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('301','302','303','304','307','308','309','399')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1'))   THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR11,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('106','206','306')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1')) THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR12,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('105','205','305')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1')) THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR13,
                                     (CASE WHEN ((A.IDPRIPUBFORN  = 'V') OR (A.IDPRIPUBCLIE = 'V')) THEN TO_CHAR((VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '65', 'I') + VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '66', 'I'))) ELSE LPAD('0',14,'0') END) AS VR19,
                                     (CASE WHEN ((A.IDPRIPUBFORN  = 'B') OR (A.IDPRIPUBCLIE = 'B')) THEN TO_CHAR((VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '65', 'I') + VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '66', 'I'))) ELSE LPAD('0',14,'0') END) AS VR20
                                FROM
                                   (SELECT VRCONTITIMP, VRIMPOSTOIT,CDSITUTRIBITNFE,VRALIQITEM,FO.IDPRIPUBFORN, CL.IDPRIPUBCLIE, IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD,CDTPCREDPICOITE
                                      FROM ITEMPROIMPOS IT, ITEMPRODUTO IP,IMPOSTO IM, NOTAFISCAL N, FILIAL F,FORNECEDOR FO, CLIENTE CL,
                                         (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                            FROM IMPOSTONF I, MAPAAPURAC M
                                           WHERE M.CDIMPOSTO     =  '60'
                                             AND M.CDEMPRESA     =  P_CDEMPRESA
                                             AND M.DTINIPERIODO  >= P_DTINICIO
                                             AND M.DTFIMPERIODO  <= P_DTFIM
                                             AND M.NRSEQUMAPAPU  =  I.NRSEQUMAPAPU) NOTA
                                     WHERE IT.CDFILIAL        = NOTA.CDFILIAL
                                       AND IT.NRLANCTONF      = NOTA.NRLANCTONF
                                       AND IT.CDIMPOSTO       = IM.CDIMPOSTO
                                       AND IM.CDIMPOSTONFE    = '60'
                                       AND IT.CDFILIAL        = IP.CDFILIAL
                                       AND IT.NRLANCTONF      = IP.NRLANCTONF
                                       AND IT.NRSEQITPROD     = IP.NRSEQITPROD
                                       AND N.CDFILIAL         = IT.CDFILIAL
                                       AND N.NRLANCTONF       = IT.NRLANCTONF
                                       AND N.CDFILIAL         = NOTA.CDFILIAL
                                       AND N.NRLANCTONF       = NOTA.NRLANCTONF
                                       AND DECODE(IDENTRSAIDOP,'S',N.CDFILIEMIT,N.CDFILIRECE) = F.CDFILIAL
                                       AND F.IDCUMUPISCOFIL   = 'S'
                                       AND N.CDFORNECED       = FO.CDFORNECED(+)
                                       AND N.CDCLIENTE        = CL.CDCLIENTE(+)
                                       AND N.IDENTRSAIDOP     = 'S'
                                   )A
                             )B
                         GROUP BY 'R25B', TO_CHAR(P_DTINICIO,'MM'),'01'

                         UNION ALL

                         SELECT (RPAD('R25B',4,' ')        ||
                                 TO_CHAR(P_DTINICIO,'MM')  ||
                                 '02'                      ||
                                 LPAD('0',14,'0')          || --Calculado automaticamente: Coluna "Contribuio" das Linhas 17A/03, 17B/03 e 17B/07.
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Valor Apurado" da Ficha 19A
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Valor Apurado" da Ficha 19B
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Contribuio Adicionada" da Ficha 21
                                 LPAD('0',14,'0')          || --Calculado automaticamente: "Contribuio Diferida" da Ficha 22
                                 LPAD('0',14,'0')          || --Calculado automaticamente: Soma das Linhas 25B/01 a 25B/07
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Para coluna 2 deve ser preenchido com zeros
                                 LPAD('0',14,'0')          || --Calculado automaticamente: Soma das Linhas 25B/08 a 25B/16
                                 LPAD('0',14,'0')          || --Cofins Retida na Fonte por rgos, Autarquias e Fundaes Federais
                                 LPAD('0',14,'0')          || --Cofins Retida na Fonte pelas Demais Entidades da Administrao Pblica Federal
                                 LPAD(LTRIM(REPLACE(TO_CHAR(SUM(NVL(B.VR19,0)),'000000000000.00'),'.')),'14','0') || --Cofins Retida na Fonte por Pessoas Jurdicas de Direito Privado
                                 LPAD(LTRIM(REPLACE(TO_CHAR(SUM(NVL(B.VR20,0)),'000000000000.00'),'.')),'14','0') || --Cofins Retida na Fonte por rgos, Autarquias e Fundaes dos Estados, Distrito Federal e Municpios
                                 LPAD('0',14,'0')          || --Cofins Retida na Fonte por Sociedade Cooperativa
                                 LPAD('0',14,'0')          || --Cofins Retida na Fonte por Fabricantes de Veculos e Mquinas
                                 LPAD('0',14,'0')          || --Cofins Substituio pela no Ocorrncia do Fato Gerador Presumido
                                 LPAD('0',14,'0')          || --Crdito Presumido  Medicamentos
                                 LPAD('0',14,'0')          || --Crditos Admitidos no Regime Cumulativo
                                 LPAD('0',14,'0')          || --Cofins Paga pelo Substituto Tributrio
                                 LPAD('0',14,'0')          || --Outras Dedues
                                 LPAD('0',14,'0')          || --Calculado automaticamente: Soma das Linhas 15B/17 a 15B/28 --Faturamento
                                 LPAD('0',14,'0')          || --Cofins a pagar de SCP
                                 LPAD('0',14,'0')          || --Cofins a pagar retida de cooperados
                                 LPAD('0',66,'0')          ||
                                 LPAD('0',10,'0'))REG_R25B
                          FROM
                             (SELECT TO_CHAR(A.VRIMPOSTOIT) AS VR01,
                                     (CASE WHEN A.CDSITUTRIBITNFE = '02' THEN  TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0')END) AS VR02,
                                     (CASE WHEN ((A.CDSITUTRIBITNFE = '05')AND(VRALIQITEM > 0.00))THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR03,
                                     (CASE WHEN A.CDSITUTRIBITNFE = '03' THEN  TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR04,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('101','102','103','104','107','108','109','199')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1')) THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR09,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('201','202','203','204','207','208','209','299')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1')) THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR10,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('301','302','303','304','307','308','309','399')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1'))   THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR11,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('106','206','306')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1')) THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR12,
                                     (CASE WHEN ((A.CDTPCREDPICOITE  IN ('105','205','305')) AND (SUBSTR(A.CDTPCREDPICOITE,1,1)= '1')) THEN TO_CHAR(A.VRIMPOSTOIT) ELSE LPAD('0',14,'0') END) AS VR13,
                                     (CASE WHEN ((A.IDPRIPUBFORN  = 'V') OR (A.IDPRIPUBCLIE = 'V')) THEN TO_CHAR((VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '65', 'I') + VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '66', 'I'))) ELSE LPAD('0',14,'0') END) AS VR19,
                                     (CASE WHEN ((A.IDPRIPUBFORN  = 'B') OR (A.IDPRIPUBCLIE = 'B')) THEN TO_CHAR((VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '65', 'I') + VALOR_IMPOSTO_ITEM_NFE(A.CDFILIAL, A.NRLANCTONF, A.NRSEQITPROD, '66', 'I'))) ELSE LPAD('0',14,'0') END) AS VR20
                                FROM
                                   (SELECT VRCONTITIMP, VRIMPOSTOIT,CDSITUTRIBITNFE,VRALIQITEM,FO.IDPRIPUBFORN, CL.IDPRIPUBCLIE, IT.CDFILIAL, IT.NRLANCTONF, IT.NRSEQITPROD,CDTPCREDPICOITE
                                      FROM ITEMPROIMPOS IT, ITEMPRODUTO IP,IMPOSTO IM, NOTAFISCAL N, FILIAL F,FORNECEDOR FO, CLIENTE CL,
                                         (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                            FROM IMPOSTONF I, MAPAAPURAC M
                                           WHERE M.CDIMPOSTO     =  '60'
                                             AND M.CDEMPRESA     =  P_CDEMPRESA
                                             AND M.DTINIPERIODO  >= P_DTINICIO
                                             AND M.DTFIMPERIODO  <= P_DTFIM
                                             AND M.NRSEQUMAPAPU  =  I.NRSEQUMAPAPU) NOTA
                                     WHERE IT.CDFILIAL        = NOTA.CDFILIAL
                                       AND IT.NRLANCTONF      = NOTA.NRLANCTONF
                                       AND IT.CDIMPOSTO       = IM.CDIMPOSTO
                                       AND IM.CDIMPOSTONFE    = '60'
                                       AND IT.CDFILIAL        = IP.CDFILIAL
                                       AND IT.NRLANCTONF      = IP.NRLANCTONF
                                       AND IT.NRSEQITPROD     = IP.NRSEQITPROD
                                       AND N.CDFILIAL         = IT.CDFILIAL
                                       AND N.NRLANCTONF       = IT.NRLANCTONF
                                       AND N.CDFILIAL         = NOTA.CDFILIAL
                                       AND N.NRLANCTONF       = NOTA.NRLANCTONF
                                       AND DECODE(IDENTRSAIDOP,'S',N.CDFILIEMIT,N.CDFILIRECE) = F.CDFILIAL
                                       AND F.IDCUMUPISCOFIL   = 'N'
                                       AND N.CDFORNECED       = FO.CDFORNECED(+)
                                       AND N.CDCLIENTE        = CL.CDCLIENTE(+)
                                       AND P_PISPASEP         = '2'
                                       AND N.IDENTRSAIDOP     = 'S'
                                   )A
                             )B
                         GROUP BY 'R25B', TO_CHAR(P_DTINICIO,'MM'),'01'
     ) LOOP
        V_CONTREG25 := NVL(V_CONTREG25,0) + 1;
        INSERT INTO ARQMAGNETICO
           (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
        VALUES
           ('25'||LPAD(RTRIM(V_CONTREG25), 8, '0'), C_REG_R25B.REG_R25B, P_NRSEQARQMAG);
     END LOOP;
     END IF;
     RETURN(V_CONTREG25);
 END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ARQUIVO_DACON_R25','5.60.000'); END;
/
