/* Teknisa - Tecnologia em Informtica

Nome: 3950_PEDFUNS.SQL



@c:\web_605\Sql\End_Conv\Oracle\3950_EXPFUNS_BUSCA_FILIALDESTINO_PEDIDO_NF.sql
*/
IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'BUSCA_FILIALDESTINO_PEDIDO_NF' AND
	           TYPE = 'FN' 			  AND
              U.UID = O.UID        AND
              U.NAME = USER)

  DROP FUNCTION BUSCA_FILIALDESTINO_PEDIDO_NF
GO


CREATE FUNCTION BUSCA_FILIALDESTINO_PEDIDO_NF(
   @P_CDFILIAL     VARCHAR(4),
   @P_NRLANCTONF   VARCHAR(10)) RETURNS VARCHAR(5000)
AS
BEGIN
   DECLARE @V_CDFILIALDEST VARCHAR(5000);
   DECLARE @V_FILIALDEST_CDFILIALPED VARCHAR(04);


   SET @V_CDFILIALDEST = '';
   DECLARE C_FILIALDEST CURSOR FOR
      SELECT DISTINCT P.CDFILIALPED
        FROM NOTAFISCAL N, ITEMPRODUTO I, PEDIDO P
       WHERE N.CDFILIAL = @P_CDFILIAL
         AND N.NRLANCTONF = @P_NRLANCTONF
         AND N.CDFILIAL = I.CDFILIAL
         AND N.NRLANCTONF = I.NRLANCTONF
         AND I.CDFILIALPED = P.CDFILIAL
         AND I.NRPEDIDO = P.NRPEDIDO;
   OPEN C_FILIALDEST;

   FETCH NEXT FROM C_FILIALDEST INTO @V_FILIALDEST_CDFILIALPED;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF (@V_FILIALDEST_CDFILIALPED IS NOT NULL) BEGIN
         IF (@V_CDFILIALDEST IS NOT NULL) BEGIN
            SET @V_CDFILIALDEST = @V_CDFILIALDEST +'-'+@V_FILIALDEST_CDFILIALPED;
         END
         ELSE BEGIN
            SET @V_CDFILIALDEST = @V_FILIALDEST_CDFILIALPED;
         END;

      END;
      FETCH NEXT FROM C_FILIALDEST INTO @V_FILIALDEST_CDFILIALPED;
   END;
   CLOSE C_FILIALDEST;
   DEALLOCATE C_FILIALDEST;

   RETURN(@V_CDFILIALDEST);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'BUSCA_FILIALDESTINO_PEDIDO_NF','0.00.000';
GO

